From 38607d8acdd9736eba1e4cf8321e9b1608a0d9e9 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Sat, 30 Sep 2017 17:56:00 +0200
Subject: [PATCH] WIP ACPICA 20170929

---
 sys/contrib/dev/acpica/changes.txt                 |  100 ++
 .../dev/acpica/generate/unix/acpiexec/Makefile     |    1 +
 sys/contrib/dev/acpica/generate/unix/iasl/Makefile |    2 +
 sys/contrib/dev/acpica/source/common/adfile.c      |    4 +-
 sys/contrib/dev/acpica/source/common/ahtable.c     |    2 +
 sys/contrib/dev/acpica/source/common/dmtable.c     |   71 +-
 sys/contrib/dev/acpica/source/common/dmtbdump.c    | 1024 +++++++++++++-------
 sys/contrib/dev/acpica/source/common/dmtbinfo.c    |  160 ++-
 .../dev/acpica/source/compiler/aslallocate.c       |  303 ++++++
 sys/contrib/dev/acpica/source/compiler/aslcache.c  |  481 +++++++++
 .../dev/acpica/source/compiler/aslcompile.c        |   66 +-
 .../dev/acpica/source/compiler/aslcompiler.h       |   71 +-
 .../dev/acpica/source/compiler/aslcompiler.l       |    4 +-
 sys/contrib/dev/acpica/source/compiler/asldebug.c  |    2 +-
 sys/contrib/dev/acpica/source/compiler/aslerror.c  |  794 +++++++++------
 sys/contrib/dev/acpica/source/compiler/aslfiles.c  |    7 +-
 sys/contrib/dev/acpica/source/compiler/aslhelp.c   |    1 +
 sys/contrib/dev/acpica/source/compiler/aslload.c   |   30 +-
 .../dev/acpica/source/compiler/aslmapenter.c       |    4 +-
 .../dev/acpica/source/compiler/aslmaputils.c       |    4 +-
 .../dev/acpica/source/compiler/aslmessages.c       |    4 +-
 .../dev/acpica/source/compiler/aslmessages.h       |    2 +
 sys/contrib/dev/acpica/source/compiler/aslmethod.c |   43 +-
 .../dev/acpica/source/compiler/asloperands.c       |    4 +-
 sys/contrib/dev/acpica/source/compiler/aslopt.c    |    2 +-
 .../dev/acpica/source/compiler/asloptions.c        |    9 +-
 .../dev/acpica/source/compiler/aslparseop.c        |   55 +-
 sys/contrib/dev/acpica/source/compiler/aslprintf.c |    4 +-
 .../dev/acpica/source/compiler/aslstartup.c        |    4 +-
 .../dev/acpica/source/compiler/aslsupport.l        |    4 +-
 sys/contrib/dev/acpica/source/compiler/asltypes.h  |    9 +-
 sys/contrib/dev/acpica/source/compiler/aslutils.c  |  221 +----
 .../dev/acpica/source/compiler/cvcompiler.c        |   16 +-
 sys/contrib/dev/acpica/source/compiler/cvparser.c  |    2 +-
 sys/contrib/dev/acpica/source/compiler/dtcompile.c |    8 +-
 .../dev/acpica/source/compiler/dtcompiler.h        |   33 +-
 sys/contrib/dev/acpica/source/compiler/dtexpress.c |    1 -
 sys/contrib/dev/acpica/source/compiler/dtfield.c   |    1 -
 sys/contrib/dev/acpica/source/compiler/dtio.c      |    5 +-
 sys/contrib/dev/acpica/source/compiler/dtparser.y  |    1 -
 .../dev/acpica/source/compiler/dtsubtable.c        |    3 +-
 sys/contrib/dev/acpica/source/compiler/dttable.c   |    1 -
 sys/contrib/dev/acpica/source/compiler/dttable1.c  |    1 -
 sys/contrib/dev/acpica/source/compiler/dttable2.c  |  377 ++++++-
 .../dev/acpica/source/compiler/dttemplate.c        |    3 +-
 .../dev/acpica/source/compiler/dttemplate.h        |   46 +-
 sys/contrib/dev/acpica/source/compiler/dtutils.c   |  153 +--
 sys/contrib/dev/acpica/source/compiler/prexpress.c |    2 -
 sys/contrib/dev/acpica/source/compiler/prmacros.c  |    2 -
 sys/contrib/dev/acpica/source/compiler/prparser.y  |    1 -
 sys/contrib/dev/acpica/source/compiler/prscan.c    |    1 -
 sys/contrib/dev/acpica/source/compiler/prutils.c   |    4 +-
 .../source/components/dispatcher/dscontrol.c       |   17 +-
 .../acpica/source/components/hardware/hwtimer.c    |   27 +-
 .../acpica/source/components/namespace/nsaccess.c  |   14 +-
 .../acpica/source/components/namespace/nssearch.c  |    1 +
 .../dev/acpica/source/components/parser/psobject.c |    9 +-
 .../dev/acpica/source/components/parser/psutils.c  |    8 +-
 .../acpica/source/components/utilities/utinit.c    |    1 -
 .../acpica/source/components/utilities/utmath.c    |    4 +-
 sys/contrib/dev/acpica/source/include/acapps.h     |    3 +
 sys/contrib/dev/acpica/source/include/acconfig.h   |    4 +-
 sys/contrib/dev/acpica/source/include/acdisasm.h   |   27 +-
 sys/contrib/dev/acpica/source/include/acexcep.h    |    4 +-
 sys/contrib/dev/acpica/source/include/aclocal.h    |    2 +-
 sys/contrib/dev/acpica/source/include/acpixf.h     |    6 +-
 sys/contrib/dev/acpica/source/include/actbl1.h     |   92 +-
 sys/contrib/dev/acpica/source/include/actbl2.h     |   14 +-
 sys/contrib/dev/acpica/source/include/actypes.h    |    2 +
 .../dev/acpica/source/tools/acpibin/abmain.c       |   21 +-
 .../dev/acpica/source/tools/acpidump/apmain.c      |   26 +-
 .../dev/acpica/source/tools/acpiexec/aecommon.h    |    1 +
 .../dev/acpica/source/tools/acpiexec/aeexception.c |   11 +-
 .../dev/acpica/source/tools/acpiexec/aeexec.c      |   13 +
 .../dev/acpica/source/tools/acpiexec/aemain.c      |   66 +-
 .../dev/acpica/source/tools/acpihelp/ahmain.c      |   21 +-
 .../dev/acpica/source/tools/acpinames/anmain.c     |   23 +-
 .../dev/acpica/source/tools/acpisrc/asmain.c       |    6 +
 .../dev/acpica/source/tools/acpisrc/astable.c      |    9 +-
 .../acpica/source/tools/acpixtract/acpixtract.c    |  241 +++--
 .../acpica/source/tools/acpixtract/acpixtract.h    |   35 +-
 .../dev/acpica/source/tools/acpixtract/axmain.c    |   23 +-
 .../dev/acpica/source/tools/acpixtract/axutils.c   |  396 +++++---
 usr.sbin/acpi/acpibin/acpibin.8                    |    4 +-
 usr.sbin/acpi/acpidump/acpidump.8                  |    4 +-
 usr.sbin/acpi/acpiexec/Makefile                    |    1 +
 usr.sbin/acpi/acpiexec/acpiexec.8                  |    8 +-
 usr.sbin/acpi/acpihelp/acpihelp.8                  |    4 +-
 usr.sbin/acpi/acpinames/acpinames.8                |    4 +-
 usr.sbin/acpi/acpixtract/acpixtract.8              |    4 +-
 usr.sbin/acpi/iasl/Makefile                        |    2 +
 91 files changed, 3655 insertions(+), 1656 deletions(-)
 create mode 100644 sys/contrib/dev/acpica/source/compiler/aslallocate.c
 create mode 100644 sys/contrib/dev/acpica/source/compiler/aslcache.c

diff --git a/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile b/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile
index 681442c375..fc45da8dc8 100644
--- a/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/acpiexec/Makefile
@@ -140,6 +140,7 @@ OBJECTS = \
 	$(OBJDIR)/hwpci.o\
 	$(OBJDIR)/hwregs.o\
 	$(OBJDIR)/hwsleep.o\
+	$(OBJDIR)/hwtimer.o\
 	$(OBJDIR)/hwvalid.o\
 	$(OBJDIR)/hwxface.o\
 	$(OBJDIR)/hwxfsleep.o\
diff --git a/sys/contrib/dev/acpica/generate/unix/iasl/Makefile b/sys/contrib/dev/acpica/generate/unix/iasl/Makefile
index 02390ea1c9..27f5d8d276 100644
--- a/sys/contrib/dev/acpica/generate/unix/iasl/Makefile
+++ b/sys/contrib/dev/acpica/generate/unix/iasl/Makefile
@@ -51,9 +51,11 @@ OBJECTS = \
 	$(OBJDIR)/ahpredef.o\
 	$(OBJDIR)/ahtable.o\
 	$(OBJDIR)/ahuuids.o\
+	$(OBJDIR)/aslallocate.o\
 	$(OBJDIR)/aslanalyze.o\
 	$(OBJDIR)/aslascii.o\
 	$(OBJDIR)/aslbtypes.o\
+	$(OBJDIR)/aslcache.o\
 	$(OBJDIR)/aslcodegen.o\
 	$(OBJDIR)/aslcompile.o\
 	$(OBJDIR)/asldebug.o\
diff --git a/sys/contrib/dev/acpica/source/common/adfile.c b/sys/contrib/dev/acpica/source/common/adfile.c
index ac96156db2..80462f1779 100644
--- a/sys/contrib/dev/acpica/source/common/adfile.c
+++ b/sys/contrib/dev/acpica/source/common/adfile.c
@@ -314,7 +314,7 @@ FlGenerateFilename (
      * Copy the original filename to a new buffer. Leave room for the worst
      * case where we append the suffix, an added dot and the null terminator.
      */
-    NewFilename = UtStringCacheCalloc ((ACPI_SIZE)
+    NewFilename = UtLocalCacheCalloc ((ACPI_SIZE)
         strlen (InputFilename) + strlen (Suffix) + 2);
     strcpy (NewFilename, InputFilename);
 
@@ -358,7 +358,7 @@ FlStrdup (
     char                *NewString;
 
 
-    NewString = UtStringCacheCalloc ((ACPI_SIZE) strlen (String) + 1);
+    NewString = UtLocalCacheCalloc ((ACPI_SIZE) strlen (String) + 1);
     strcpy (NewString, String);
     return (NewString);
 }
diff --git a/sys/contrib/dev/acpica/source/common/ahtable.c b/sys/contrib/dev/acpica/source/common/ahtable.c
index 7aee3c669b..be68ed480c 100644
--- a/sys/contrib/dev/acpica/source/common/ahtable.c
+++ b/sys/contrib/dev/acpica/source/common/ahtable.c
@@ -232,6 +232,7 @@ const AH_TABLE      Gbl_AcpiSupportedTables[] =
     {ACPI_SIG_MTMR, "MID Timer Table"},
     {ACPI_SIG_NFIT, "NVDIMM Firmware Interface Table"},
     {ACPI_SIG_PCCT, "Platform Communications Channel Table"},
+    {ACPI_SIG_PDTT, "Platform Debug Trigger Table"},
     {ACPI_SIG_PMTT, "Platform Memory Topology Table"},
     {ACPI_SIG_PPTT, "Processor Properties Topology Table"},
     {ACPI_SIG_RASF, "RAS Features Table"},
@@ -240,6 +241,7 @@ const AH_TABLE      Gbl_AcpiSupportedTables[] =
     {ACPI_SIG_S3PT, "S3 Performance Table"},
     {ACPI_SIG_SBST, "Smart Battery Specification Table"},
     {ACPI_SIG_SDEI, "Software Delegated Exception Interface Table"},
+    {ACPI_SIG_SDEV, "Secure Devices table"},
     {ACPI_SIG_SLIC, "Software Licensing Description Table"},
     {ACPI_SIG_SLIT, "System Locality Information Table"},
     {ACPI_SIG_SPCR, "Serial Port Console Redirection table"},
diff --git a/sys/contrib/dev/acpica/source/common/dmtable.c b/sys/contrib/dev/acpica/source/common/dmtable.c
index 38248c2c45..07d27faf78 100644
--- a/sys/contrib/dev/acpica/source/common/dmtable.c
+++ b/sys/contrib/dev/acpica/source/common/dmtable.c
@@ -154,7 +154,6 @@
 #include "acdisasm.h"
 #include "actables.h"
 #include "aslcompiler.h"
-#include "dtcompiler.h"
 
 /* This module used for application-level code only */
 
@@ -290,9 +289,9 @@ static const char           *AcpiDmHestSubnames[] =
     "IA-32 Machine Check Exception",
     "IA-32 Corrected Machine Check",
     "IA-32 Non-Maskable Interrupt",
-    "Unknown SubTable Type",        /* 3 - Reserved */
-    "Unknown SubTable Type",        /* 4 - Reserved */
-    "Unknown SubTable Type",        /* 5 - Reserved */
+    "Unknown Subtable Type",        /* 3 - Reserved */
+    "Unknown Subtable Type",        /* 4 - Reserved */
+    "Unknown Subtable Type",        /* 5 - Reserved */
     "PCI Express Root Port AER",
     "PCI Express AER (AER Endpoint)",
     "PCI Express/PCI-X Bridge AER",
@@ -374,7 +373,7 @@ static const char           *AcpiDmPmttSubnames[] =
 {
     "Socket",                       /* ACPI_PMTT_TYPE_SOCKET */
     "Memory Controller",            /* ACPI_PMTT_TYPE_CONTROLLER */
-    "Physical Component (DIMM)",    /* ACPI_PMTT_TYPE_DIMM  */
+    "Physical Component (DIMM)",    /* ACPI_PMTT_TYPE_DIMM */
     "Unknown Subtable Type"         /* Reserved */
 };
 
@@ -382,7 +381,14 @@ static const char           *AcpiDmPpttSubnames[] =
 {
     "Processor Hierarchy Node",     /* ACPI_PPTT_TYPE_PROCESSOR */
     "Cache Type",                   /* ACPI_PPTT_TYPE_CACHE */
-    "ID",                           /* ACPI_PMTT_TYPE_ID  */
+    "ID",                           /* ACPI_PPTT_TYPE_ID */
+    "Unknown Subtable Type"         /* Reserved */
+};
+
+static const char           *AcpiDmSdevSubnames[] =
+{
+    "Namespace Device",             /* ACPI_SDEV_TYPE_NAMESPACE_DEVICE */
+    "PCIe Endpoint Device",         /* ACPI_SDEV_TYPE_PCIE_ENDPOINT_DEVICE */
     "Unknown Subtable Type"         /* Reserved */
 };
 
@@ -396,6 +402,23 @@ static const char           *AcpiDmSratSubnames[] =
     "Unknown Subtable Type"         /* Reserved */
 };
 
+static const char           *AcpiDmTpm2Subnames[] =
+{
+    "Illegal Start Method value",
+    "Reserved",
+    "ACPI Start Method",
+    "Reserved",
+    "Reserved",
+    "Reserved",
+    "Memory Mapped I/O",
+    "Command Response Buffer",
+    "Command Response Buffer with ACPI Start Method",
+    "Reserved",
+    "Reserved",
+    "Command Response Buffer with ARM SMC",
+    "Unknown Subtable Type"         /* Reserved */
+};
+
 static const char           *AcpiDmIvrsSubnames[] =
 {
     "Hardware Definition Block",
@@ -487,6 +510,7 @@ const ACPI_DMTABLE_DATA     AcpiDmTableData[] =
     {ACPI_SIG_MTMR, NULL,                   AcpiDmDumpMtmr, DtCompileMtmr,  TemplateMtmr},
     {ACPI_SIG_NFIT, AcpiDmTableInfoNfit,    AcpiDmDumpNfit, DtCompileNfit,  TemplateNfit},
     {ACPI_SIG_PCCT, AcpiDmTableInfoPcct,    AcpiDmDumpPcct, DtCompilePcct,  TemplatePcct},
+    {ACPI_SIG_PDTT, AcpiDmTableInfoPdtt,    AcpiDmDumpPdtt, DtCompilePdtt,  TemplatePdtt},
     {ACPI_SIG_PMTT, NULL,                   AcpiDmDumpPmtt, DtCompilePmtt,  TemplatePmtt},
     {ACPI_SIG_PPTT, NULL,                   AcpiDmDumpPptt, DtCompilePptt,  TemplatePptt},
     {ACPI_SIG_RASF, AcpiDmTableInfoRasf,    NULL,           NULL,           TemplateRasf},
@@ -494,6 +518,7 @@ const ACPI_DMTABLE_DATA     AcpiDmTableData[] =
     {ACPI_SIG_S3PT, NULL,                   NULL,           NULL,           TemplateS3pt},
     {ACPI_SIG_SBST, AcpiDmTableInfoSbst,    NULL,           NULL,           TemplateSbst},
     {ACPI_SIG_SDEI, AcpiDmTableInfoSdei,    NULL,           NULL,           TemplateSdei},
+    {ACPI_SIG_SDEV, AcpiDmTableInfoSdev,    AcpiDmDumpSdev, DtCompileSdev,  TemplateSdev},
     {ACPI_SIG_SLIC, NULL,                   AcpiDmDumpSlic, DtCompileSlic,  TemplateSlic},
     {ACPI_SIG_SLIT, NULL,                   AcpiDmDumpSlit, DtCompileSlit,  TemplateSlit},
     {ACPI_SIG_SPCR, AcpiDmTableInfoSpcr,    NULL,           NULL,           TemplateSpcr},
@@ -501,7 +526,7 @@ const ACPI_DMTABLE_DATA     AcpiDmTableData[] =
     {ACPI_SIG_SRAT, NULL,                   AcpiDmDumpSrat, DtCompileSrat,  TemplateSrat},
     {ACPI_SIG_STAO, NULL,                   AcpiDmDumpStao, DtCompileStao,  TemplateStao},
     {ACPI_SIG_TCPA, NULL,                   AcpiDmDumpTcpa, DtCompileTcpa,  TemplateTcpa},
-    {ACPI_SIG_TPM2, AcpiDmTableInfoTpm2,    NULL,           NULL,           TemplateTpm2},
+    {ACPI_SIG_TPM2, AcpiDmTableInfoTpm2,    AcpiDmDumpTpm2, DtCompileTpm2,  TemplateTpm2},
     {ACPI_SIG_UEFI, AcpiDmTableInfoUefi,    NULL,           DtCompileUefi,  TemplateUefi},
     {ACPI_SIG_VRTC, AcpiDmTableInfoVrtc,    AcpiDmDumpVrtc, DtCompileVrtc,  TemplateVrtc},
     {ACPI_SIG_WAET, AcpiDmTableInfoWaet,    NULL,           NULL,           TemplateWaet},
@@ -917,6 +942,7 @@ AcpiDmDumpTable (
         case ACPI_DMT_PCCT:
         case ACPI_DMT_PMTT:
         case ACPI_DMT_PPTT:
+        case ACPI_DMT_SDEV:
         case ACPI_DMT_SRAT:
         case ACPI_DMT_ASF:
         case ACPI_DMT_HESTNTYP:
@@ -948,6 +974,7 @@ AcpiDmDumpTable (
         case ACPI_DMT_NAME4:
         case ACPI_DMT_SIG:
         case ACPI_DMT_LPIT:
+        case ACPI_DMT_TPM2:
 
             ByteLength = 4;
             break;
@@ -1583,6 +1610,20 @@ AcpiDmDumpTable (
                 CurrentOffset, NULL);
             break;
 
+        case ACPI_DMT_SDEV:
+
+            /* SDEV subtable types */
+
+            Temp8 = *Target;
+            if (Temp8 > ACPI_SDEV_TYPE_RESERVED)
+            {
+                Temp8 = ACPI_SDEV_TYPE_RESERVED;
+            }
+
+            AcpiOsPrintf (UINT8_FORMAT, *Target,
+                AcpiDmSdevSubnames[Temp8]);
+            break;
+
         case ACPI_DMT_SRAT:
 
             /* SRAT subtable types */
@@ -1597,6 +1638,22 @@ AcpiDmDumpTable (
                 AcpiDmSratSubnames[Temp8]);
             break;
 
+        case ACPI_DMT_TPM2:
+
+            /* TPM2 Start Method types */
+
+            Temp8 = *Target;
+            if (Temp8 > ACPI_TPM2_RESERVED)
+            {
+                Temp8 = ACPI_TPM2_RESERVED;
+            }
+
+            AcpiOsPrintf (UINT8_FORMAT, *Target,
+                AcpiDmTpm2Subnames[Temp8]);
+            break;
+
+
+
         case ACPI_DMT_FADTPM:
 
             /* FADT Preferred PM Profile names */
